/*****************************************************************/
/*                                                               */
/*   inp Library  ver 0.40                                       */
/*                                                               */
/*   written by sentaro21                                        */
/*                                                               */
/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fxlib.h>
#include "fx_syscall.h"
#include "inp.h"


//----------------------------------------------------------------------------------------------

char* InputStrSub(int x, int y, int width, int csrX, char* buffer, char SPC, int rev_mode, int exp_mode, int alpha_mode) {
	char buffer2[32];
	int i,j;
	unsigned int key=0;
	int numX=csrX;
	int cont=1;

	for(i=0; i<22; i++) buffer2[i]=buffer[i]; // backup

	Cursor_SetFlashMode(1);			// cursor flashing on
	if (Cursor_GetFlashStyle()<0x6) {
		Cursor_SetFlashStyle(0);	// insert mode cursor 
		Cursor_SetFlashOn(0);
		}
		else {
		Cursor_SetFlashStyle(0x10);	// overwrite mode cursor 
		Cursor_SetFlashOn(0x6);	
	}

	while (cont) {
		buffer[width]='\0';
		locate(x,y); Print((unsigned char*)buffer);
		if ( rev_mode )	{ locate(x+numX,y); PrintRev((unsigned char*)buffer+numX); }
		Cursor_SetPosition(x+csrX-1,y-1);
	
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_AC:
				csrX=0; numX=0;
				for(i=csrX; i<width; i++) buffer[i]=SPC;
				break;
			case KEY_CTRL_EXIT:
				cont=0;
				for(i=0; i<22; i++) buffer[i]=buffer2[i]; // recover
				break;
			case KEY_CTRL_EXE:
				cont=0;
				break;
			case KEY_CTRL_DEL:
				if (csrX==0) {
					if (numX>0) {
						for(i=csrX; i<numX; i++) buffer[i]=buffer[i+1];
						numX--;
					}
				}
				if (csrX>0) {
					if (Cursor_GetFlashStyle()<0x6) {	// insert mode
						for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
						csrX--;
						numX--;
					}
					else {								// overwrite mode
						if (csrX==numX) {
							for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
							csrX--;
							numX--;
						}
						else {
							for(i=csrX  ; i<width; i++) buffer[i]=buffer[i+1];
							numX--;
						}
					}
				}
				buffer[numX]=SPC;
				break;
			case KEY_CTRL_LEFT:
				if (csrX>0) {
					csrX--;
				}
				break;
			case KEY_CTRL_RIGHT:
				if (csrX<numX) {
					csrX++;
				}
				break;
			case KEY_CTRL_UP:
					csrX=0; 
				break;
			case KEY_CTRL_DOWN:
					csrX=numX;
				break;
			default:
				break;
		}
		if (
		   ( KEY_CHAR_0 <= key  ) && ( key <= KEY_CHAR_9     ) ||
		   ( key == KEY_CHAR_DP ) || ( key == KEY_CHAR_MINUS ) || ( key == KEY_CHAR_PMINUS ) ||
		   ( exp_mode && ( key == KEY_CHAR_EXP )  ) ||
		   ( alpha_mode && ( ' ' <= key  ) && ( key <= '~' ) )
		   ) {
			
			if ( key == KEY_CHAR_MINUS )  key='-';
			if ( key == KEY_CHAR_PMINUS ) key='-';
			if ( key == KEY_CHAR_EXP )    key='e';
			
			if (csrX<width) {
				if (csrX<numX) {
					if (Cursor_GetFlashStyle()<0x6) {
						if (numX<width) {		// insert mode
							for(i=width; i>csrX; i--) buffer[i]=buffer[i-1];
							buffer[csrX]=key;
							numX++;
							csrX++;
						}
					}
					else {				// overwrite mode
							buffer[csrX]=key;
							if (csrX<width) csrX++;
					}
				}
				else {					// new
					buffer[csrX]=key;
					csrX++; if (csrX>numX) numX=csrX;
				}
			}
		}
	}

	Cursor_SetFlashMode(0);
	
	buffer[numX]='\0';
	return (buffer);
}

//----------------------------------------------------------------------------------------------
void sprintG(char* buffer, double num, int width, int round) {
	int i;
	double minus=0,adj;
    
	if ( num < 0 ) minus=-1;
	if ( ( fabs(num) < pow(10,width+minus) ) && ( ( fabs(num)-floor(fabs(num)) ) == 0 ) ) {
		sprintf(buffer,"%.0f",num);		// integer
	}
	else { 
		if ( ( 0.01 <= fabs(num) ) && ( fabs(num) < pow(10,width+minus) ) ) {
			adj=0;
			if ( round ) { adj = pow(10,-round+ floor(log10(fabs(num))) ) * 5 ; if (minus) adj=-adj;
			}
			sprintf(buffer,"%.15f",num+adj);
		}
		else {                     sprintf(buffer,"%.15g",num);
			adj = floor(log10(log10(fabs(num)))) - minus;
			if ( width == 19+adj ) sprintf(buffer,"%.14g",num);
			if ( width == 18+adj ) sprintf(buffer,"%.13g",num);
			if ( width == 17+adj ) sprintf(buffer,"%.12g",num);
			if ( width == 16+adj ) sprintf(buffer,"%.11g",num);
			if ( width == 15+adj ) sprintf(buffer,"%.10g",num);
			if ( width == 14+adj ) sprintf(buffer,"%.9g",num);
			if ( width == 13+adj ) sprintf(buffer,"%.8g",num);
			if ( width == 12+adj ) sprintf(buffer,"%.7g",num);
			if ( width == 11+adj ) sprintf(buffer,"%.6g",num);
			if ( width == 10+adj ) sprintf(buffer,"%.5g",num);
			if ( width ==  9+adj ) sprintf(buffer,"%.4g",num);
			if ( width ==  8+adj ) sprintf(buffer,"%.3g",num);
			if ( width ==  7+adj ) sprintf(buffer,"%.2g",num);
			if ( width <   7+adj ) sprintf(buffer,"%.1g",num);
		}
	}
	buffer[width]='\0';

	if ( ( strchr(buffer,'.') != '\0' ) && ( strchr(buffer,'e') == '\0' ) ) {
		i=width-1;		// zero cut
		while ( buffer[i]=='0' ) { buffer[i]='\0'; i--; }
	}
	return ;
}

//----------------------------------------------------------------------------------------------
double InputNumD(int x, int y, int width, double defaultNum, char SPC, int rev_mode, int exp_mode, int round) {		// 0123456789.(-)exp
	char buffer[32];
	int i,csrX=0;

	for(i=0; i<22; i++) buffer[i]=SPC;
	if ( defaultNum != 0 ) {
		sprintG(buffer,defaultNum,width,round);
		csrX=strlen(buffer);
	}
	buffer[width]='\0';
	
	return atof( InputStrSub( x, y, width, csrX, buffer, SPC, rev_mode, exp_mode, ALPHA_OFF) );
}


char* InputStr(int x, int y, int width, char* buffer, char SPC, int rev_mode) {		// ABCDEF0123456789.(-)exp
	char buffer2[32];
	int i,csrX=0;

	for(i=0; i<22; i++) buffer2[i]=SPC;
	if ( strlen(buffer) != 0 ) {
		sprintf(buffer2,"%s",buffer);
		csrX=strlen(buffer2);
	}
	buffer2[width]='\0';
	
	InputStrSub( x, y, width, csrX, buffer2, SPC, rev_mode, EXP_ON, ALPHA_ON);

	for(i=0; i<22; i++) buffer[i]=buffer2[i]; // 

	return ( buffer );
}


