/*****************************************************************/
/*                                                               */
/*   tmp conv ver 1.00.40                                        */
/*                                                               */
/*   written by sentaro21                                        */
/*                                                               */
/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fxlib.h>
#include "inp.h"

//----------------------------------------------------------------------------------------------
double defaultnumD=0;

void InputTestD(){
	int i,j;
	char buffer[32];
	unsigned int key=0;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"InpD=");

	defaultnumD=InputNumD(1,2, 20, defaultnumD, ' ', REV_OFF, EXP_ON, 17);
	
	locate(1,3); Print((unsigned char*)" num=");
	locate(1,4); sprintG(buffer,defaultnumD,20,17); Print((unsigned char*)buffer);

	GetKey(&key);
}
//----------------------------------------------------------------------------------------------
char defaultStr[23]="ABC";

void InputTestS(){
	int i,j;
	char buffer[32];
	char buffer2[32];
	unsigned int key=0;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"InpS=");
	strcpy(buffer2,InputStr(1,2, 20, defaultStr, ' ', REV_OFF));
	locate(1,4); sprintf(buffer,"%s",buffer2); Print((unsigned char*)buffer);
	strcpy(defaultStr,buffer2);

	GetKey(&key);
}

//----------------------------------------------------------------------------------------------
void FMLA(){
	unsigned int key;

	SaveDisp(SAVEDISP_PAGE1);		// --------
	PopUpWin(6);
	
	locate( 3,2); Print((unsigned char *) "=Conversion FMLA=");
	locate( 3,4); Print((unsigned char *) "C = 5*(F-32)/9");
	locate( 3,5); Print((unsigned char *) "F = (9/5)*C+32");
	locate( 3,6); Print((unsigned char *) "K = C+273.15");
	locate(14,7); Print((unsigned char *) "<EXIT>");
	Bdisp_PutDisp_DD();

	while ( 1 ) {
		GetKey(&key);
		if ( key == KEY_CTRL_EXIT ) break;
		if ( key == KEY_CTRL_AC   ) break;
	}
	
	RestoreDisp(SAVEDISP_PAGE1);	// --------
	Bdisp_PutDisp_DD();
}


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;
	double C=0,F=0,K=0,A=0;
	char buffer[32];
	unsigned char ctemp[]={0x8c,0};

	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		locate( 1,1);Print((unsigned char*)"===Temp Converter===");
		locate( 1,3);Print((unsigned char*)"1:             C");  locate(15,3); Print(ctemp);
		locate( 1,4);Print((unsigned char*)"2:             F");  locate(15,4); Print(ctemp);
		locate( 1,5);Print((unsigned char*)"3:             K");
		locate( 1,7);Print((unsigned char*)"<VARS>:FMLA");
		locate(15,7);Print((unsigned char*)"<EXIT>");
		if ( A==1 ) {
			sprintG(buffer,C,10, 9); locate( 4,3) ;Print((unsigned char*)buffer);
			sprintG(buffer,F,10, 9); locate( 4,4) ;Print((unsigned char*)buffer);
			sprintG(buffer,K,10, 9); locate( 4,5) ;Print((unsigned char*)buffer);
		}
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_VARS:
				FMLA();		// FMLA POPUP
				break;
			case KEY_CHAR_1:
				C=InputNumD(4,3, 10, 0, '>',REV_OFF , EXP_OFF, 9);	// C
				F=C*9./5.+32;
				K=C+273.15;
				A=1;
				break;
			case KEY_CHAR_2:
				F=InputNumD(4,4, 10, 0, ' ',REV_ON, EXP_OFF, 9);	// F
				C=5.*(F-32.)/9.;
				K=C+273.15;
				A=1;
				break;
			case KEY_CHAR_3:
				K=InputNumD(4,5, 10, K, ' ',REV_OFF, EXP_ON, 9);	// K
				C=K-273.15;
				F=C*9./5.+32;
				A=1;
				break;
			case KEY_CTRL_OPTN:
				InputTestD();		// input double test
				break;
			case KEY_CHAR_POW:
				InputTestS();		// input String test
				break;
			case KEY_CTRL_EXIT:
				cont=0;
				break;
			default:
				break;
		}
	}

	return 1;
}



//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

